unit TTTServer_TLB;

// ************************************************************************ //
// WARNING                                                                    
// -------                                                                    
// The types declared in this file were generated from data read from a       
// Type Library. If this type library is explicitly or indirectly (via        
// another type library referring to this type library) re-imported, or the   
// 'Refresh' command of the Type Library Editor activated while editing the   
// Type Library, the contents of this file will be regenerated and all        
// manual modifications will be lost.                                         
// ************************************************************************ //

// PASTLWTR : $Revision:   1.79  $
// File generated on 8/15/99 2:51:12 AM from Type Library described below.

// ************************************************************************ //
// Type Lib: C:\work\d5dg\code\Ch23\TTT\TTTServer.tlb (1)
// IID\LCID: {BA02A6A0-FD07-11D2-AF31-0000861EF0BB}\0
// Helpfile: 
// DepndLst: 
//   (1) v2.0 stdole, (c:\windows\SYSTEM\StdOle2.Tlb)
//   (2) v4.0 StdVCL, (C:\Program Files\Borland\CBuilder4\Bin\stdvcl40.tlb)
// ************************************************************************ //
interface

uses Windows, ActiveX, Classes, Graphics, OleServer, OleCtrls, StdVCL;

// *********************************************************************//
// GUIDS declared in the TypeLibrary. Following prefixes are used:        
//   Type Libraries     : LIBID_xxxx                                      
//   CoClasses          : CLASS_xxxx                                      
//   DISPInterfaces     : DIID_xxxx                                       
//   Non-DISP interfaces: IID_xxxx                                        
// *********************************************************************//
const
  // TypeLibrary Major and minor versions
  TTTServerMajorVersion = 1;
  TTTServerMinorVersion = 0;

  LIBID_TTTServer: TGUID = '{BA02A6A0-FD07-11D2-AF31-0000861EF0BB}';

  IID_IGameServer: TGUID = '{BA02A6A1-FD07-11D2-AF31-0000861EF0BB}';
  CLASS_GameServer: TGUID = '{BA02A6A3-FD07-11D2-AF31-0000861EF0BB}';

// *********************************************************************//
// Declaration of Enumerations defined in Type Library                    
// *********************************************************************//
// SkillLevels constants
type
  SkillLevels = TOleEnum;
const
  slUnconcious = $00000000;
  slAwake = $00000001;

// GameResults constants
type
  GameResults = TOleEnum;
const
  grInProgress = $00000000;
  grTie = $00000001;
  grPlayerWin = $00000002;
  grComputerWin = $00000003;

type

// *********************************************************************//
// Forward declaration of types defined in TypeLibrary                    
// *********************************************************************//
  IGameServer = interface;
  IGameServerDisp = dispinterface;

// *********************************************************************//
// Declaration of CoClasses defined in Type Library                       
// (NOTE: Here we map each CoClass to its Default Interface)              
// *********************************************************************//
  GameServer = IGameServer;


// *********************************************************************//
// Interface: IGameServer
// Flags:     (4416) Dual OleAutomation Dispatchable
// GUID:      {BA02A6A1-FD07-11D2-AF31-0000861EF0BB}
// *********************************************************************//
  IGameServer = interface(IDispatch)
    ['{BA02A6A1-FD07-11D2-AF31-0000861EF0BB}']
    procedure NewGame(out GameID: Integer); safecall;
    procedure PlayerMove(GameID: Integer; X: Integer; Y: Integer; out GameRez: GameResults); safecall;
    procedure ComputerMove(GameID: Integer; SkillLevel: SkillLevels; out X: Integer; 
                           out Y: Integer; out GameRez: GameResults); safecall;
  end;

// *********************************************************************//
// DispIntf:  IGameServerDisp
// Flags:     (4416) Dual OleAutomation Dispatchable
// GUID:      {BA02A6A1-FD07-11D2-AF31-0000861EF0BB}
// *********************************************************************//
  IGameServerDisp = dispinterface
    ['{BA02A6A1-FD07-11D2-AF31-0000861EF0BB}']
    procedure NewGame(out GameID: Integer); dispid 1;
    procedure PlayerMove(GameID: Integer; X: Integer; Y: Integer; out GameRez: GameResults); dispid 2;
    procedure ComputerMove(GameID: Integer; SkillLevel: SkillLevels; out X: Integer; 
                           out Y: Integer; out GameRez: GameResults); dispid 3;
  end;

// *********************************************************************//
// The Class CoGameServer provides a Create and CreateRemote method to          
// create instances of the default interface IGameServer exposed by              
// the CoClass GameServer. The functions are intended to be used by             
// clients wishing to automate the CoClass objects exposed by the         
// server of this typelibrary.                                            
// *********************************************************************//
  CoGameServer = class
    class function Create: IGameServer;
    class function CreateRemote(const MachineName: string): IGameServer;
  end;


// *********************************************************************//
// OLE Server Proxy class declaration
// Server Object    : TGameServer
// Help String      : GameServer Object
// Default Interface: IGameServer
// Def. Intf. DISP? : No
// Event   Interface: 
// TypeFlags        : (2) CanCreate
// *********************************************************************//
{$IFDEF LIVE_SERVER_AT_DESIGN_TIME}
  TGameServerProperties= class;
{$ENDIF}
  TGameServer = class(TOleServer)
  private
    FIntf:        IGameServer;
{$IFDEF LIVE_SERVER_AT_DESIGN_TIME}
    FProps:       TGameServerProperties;
    function      GetServerProperties: TGameServerProperties;
{$ENDIF}
    function      GetDefaultInterface: IGameServer;
  protected
    procedure InitServerData; override;
  public
    constructor Create(AOwner: TComponent); override;
    destructor  Destroy; override;
    procedure Connect; override;
    procedure ConnectTo(svrIntf: IGameServer);
    procedure Disconnect; override;
    procedure NewGame(out GameID: Integer);
    procedure PlayerMove(GameID: Integer; X: Integer; Y: Integer; out GameRez: GameResults);
    procedure ComputerMove(GameID: Integer; SkillLevel: SkillLevels; out X: Integer; 
                           out Y: Integer; out GameRez: GameResults);
    property  DefaultInterface: IGameServer read GetDefaultInterface;
  published
{$IFDEF LIVE_SERVER_AT_DESIGN_TIME}
    property Server: TGameServerProperties read GetServerProperties;
{$ENDIF}
  end;

{$IFDEF LIVE_SERVER_AT_DESIGN_TIME}
// *********************************************************************//
// OLE Server Properties Proxy Class
// Server Object    : TGameServer
// (This object is used by the IDE's Property Inspector to allow editing
//  of the properties of this server)
// *********************************************************************//
 TGameServerProperties = class(TPersistent)
  private
    FServer:    TGameServer;
    function    GetDefaultInterface: IGameServer;
    constructor Create(AServer: TGameServer);
  protected
  public
    property DefaultInterface: IGameServer read GetDefaultInterface;
  published
  end;
{$ENDIF}


procedure Register;

implementation

uses ComObj;

class function CoGameServer.Create: IGameServer;
begin
  Result := CreateComObject(CLASS_GameServer) as IGameServer;
end;

class function CoGameServer.CreateRemote(const MachineName: string): IGameServer;
begin
  Result := CreateRemoteComObject(MachineName, CLASS_GameServer) as IGameServer;
end;

procedure TGameServer.InitServerData;
const
  CServerData: TServerData = (
    ClassID:   '{BA02A6A3-FD07-11D2-AF31-0000861EF0BB}';
    IntfIID:   '{BA02A6A1-FD07-11D2-AF31-0000861EF0BB}';
    EventIID:  '';
    LicenseKey: nil;
    Version: 500);
begin
  ServerData := @CServerData;
end;

procedure TGameServer.Connect;
var
  punk: IUnknown;
begin
  if FIntf = nil then
  begin
    punk := GetServer;
    Fintf:= punk as IGameServer;
  end;
end;

procedure TGameServer.ConnectTo(svrIntf: IGameServer);
begin
  Disconnect;
  FIntf := svrIntf;
end;

procedure TGameServer.DisConnect;
begin
  if Fintf <> nil then
  begin
    FIntf := nil;
  end;
end;

function TGameServer.GetDefaultInterface: IGameServer;
begin
  if FIntf = nil then
    Connect;
  Assert(FIntf <> nil, 'DefaultInterface is NULL. Component is not connected to Server. You must call ''Connect'' or ''ConnectTo'' before this operation');
  Result := FIntf;
end;

constructor TGameServer.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
{$IFDEF LIVE_SERVER_AT_DESIGN_TIME}
  FProps := TGameServerProperties.Create(Self);
{$ENDIF}
end;

destructor TGameServer.Destroy;
begin
{$IFDEF LIVE_SERVER_AT_DESIGN_TIME}
  FProps.Free;
{$ENDIF}
  inherited Destroy;
end;

{$IFDEF LIVE_SERVER_AT_DESIGN_TIME}
function TGameServer.GetServerProperties: TGameServerProperties;
begin
  Result := FProps;
end;
{$ENDIF}

procedure TGameServer.NewGame(out GameID: Integer);
begin
  DefaultInterface.NewGame(GameID);
end;

procedure TGameServer.PlayerMove(GameID: Integer; X: Integer; Y: Integer; out GameRez: GameResults);
begin
  DefaultInterface.PlayerMove(GameID, X, Y, GameRez);
end;

procedure TGameServer.ComputerMove(GameID: Integer; SkillLevel: SkillLevels; out X: Integer; 
                                   out Y: Integer; out GameRez: GameResults);
begin
  DefaultInterface.ComputerMove(GameID, SkillLevel, X, Y, GameRez);
end;

{$IFDEF LIVE_SERVER_AT_DESIGN_TIME}
constructor TGameServerProperties.Create(AServer: TGameServer);
begin
  inherited Create;
  FServer := AServer;
end;

function TGameServerProperties.GetDefaultInterface: IGameServer;
begin
  Result := FServer.DefaultInterface;
end;

{$ENDIF}

procedure Register;
begin
  RegisterComponents('Servers',[TGameServer]);
end;

end.
